<?php

function wp_beifen_process_ajax_request($request_options)
{
	// Check if directory exists
	if(!file_exists($request_options['backup_directory']))
	{
		// No, can create it?
		if(!@mkdir($request_options['backup_directory']))
		{
			// No, return error message
			$result['status'] = __("Error", WP_BEIFEN_DOMAIN);
			$result['message'] = __("The backup directory does not exist and cannot be created!", WP_BEIFEN_DOMAIN);
			return $result;
		}
	}
	// Is file a directory ?
	if(!is_dir($request_options['backup_directory']))
	{
		// No, return error message
		$result['status'] = __("Error", WP_BEIFEN_DOMAIN);
		$result['message'] = __("The path is not a valid directory!", WP_BEIFEN_DOMAIN);
		return $result;
	}
	// Is directory writable?
	if(!is_writable($request_options['backup_directory']))
	{
		// No, return error message
		$result['status'] = __("Error", WP_BEIFEN_DOMAIN);
		$result['message'] = __("The backup directory is not writable!", WP_BEIFEN_DOMAIN);
		return $result;
	}
	
	// All checks ok, update options
	if(!defined(DS)) define('DS',DIRECTORY_SEPARATOR);
	// Check for trailing slash
	if($request_options['backup_directory'][strlen($request_options['backup_directory'])-1] != DS)
	{
		$request_options['backup_directory'] .= DS;
	}
	// change options
	$options = get_option(WP_BEIFEN_OPTIONS);
	$options['plugin_backup_directory'] = $request_options['backup_directory'];
	$options['plugin_ready'] = true;
	update_option(WP_BEIFEN_OPTIONS ,$options);
	
	// Return success message
	$result['status'] = __("Success", WP_BEIFEN_DOMAIN);
	$result['message'] = __("All changes were saved successfully!", WP_BEIFEN_DOMAIN);	
	return $result;
}

?>