<?php
// Get options
$options = get_option(WP_BEIFEN_OPTIONS);
// Nonce for AJAX activity
$nonce = wp_create_nonce(WP_BEIFEN_NONCE);
?>
<script  type='text/javascript'>
jQuery(document).ready(function(){
	jQuery("div.updated").hide();
	
	jQuery("#wp_beifen_submit").click(function () {
		// Disable form inputs
		jQuery('#wp_beifen_form :input').attr('disabled', true);
		// Change update message
		jQuery("#update_message").html("<p><img src=\"<?php echo admin_url(); ?>images/loading.gif\" /><?php _e("Creating backup, please don't leave this page!", WP_BEIFEN_DOMAIN); ?></p>");
		// show update message
		jQuery("#update_message").show();
		// prepare form data
		var options = 'backup_name=' + jQuery("#backup_name").attr("value")
					+ '&'
					+ 'backup_type=' + jQuery('#backup_type option:selected').val()
					+ '&'
					+ 'compress_backup=' + jQuery('.compress_backup:checked').attr("value");
		// send ajax request to save new settings
		send_request('create_backup', options, display_backup_result);
    });
	
	
	// send AJAX request
	function send_request(requested_task, options, callback)
	{
		jQuery.ajax({
			type: "post",url: "admin-ajax.php",data: { action: 'wp_beifen_ajax_handler', task:requested_task, parameters:options, _ajax_nonce: '<?php echo $nonce; ?>' },
			beforeSend: function() {},
			complete: function() {},
			success: function(html){
				result = eval("(" + html + ')');
				callback(result);
			}
		})
	}
	
	function display_backup_result(result)
	{
		var message = '<h3>' + result.status + '!</h3>'
					+ '<p>' + result.message + '!</p>';
		// Change update message
		jQuery("#update_message").html(message);
		// Enable form inputs
		jQuery('#wp_beifen_form :input').attr('disabled', false);
	}
})
</script>
<div class="wrap">
	<h2><?php _e("Create New Backup", WP_BEIFEN_DOMAIN); ?></h2>
	<div id="update_message" class="updated"></div>
	<?php
		if(!$options['plugin_ready'])
		{
			?>
				<p><?php _e("Please review your settings before first use.", WP_BEIFEN_DOMAIN); ?> <?php _e("You can do so", WP_BEIFEN_DOMAIN); ?> <a href="<?php echo admin_url(); ?>admin.php?page=<?php echo basename($options['plugin_location']); ?>/beifen.php"><?php _e("here", WP_BEIFEN_DOMAIN); ?></a>.
			<?php
		}
		else
		{
			?>
				<form id="wp_beifen_form">
					<table class="form-table">
						<tr valign="top">
							<th scope="row"><label for="backup_name"><?php _e("Backup Name", WP_BEIFEN_DOMAIN); ?></label></th>
							<td>
								<input name="backup_name" type="text" id="backup_name" value="<?php echo date('Ymd-Hi'); ?>" class="regular-text" />
							</td>
						</tr>
						<tr valign="top">
							<th scope="row"><label for="backup_type"><?php _e("Backup Type", WP_BEIFEN_DOMAIN); ?></label></th>
							<td>
								<select name="backup_type" id="backup_type">
									<option value="Full"><?php _e("Full", WP_BEIFEN_DOMAIN); ?></option>
									<option value="Files"><?php _e("Files Only", WP_BEIFEN_DOMAIN); ?></option>
									<option value="DB"><?php _e("Database Only", WP_BEIFEN_DOMAIN); ?></option>
								</select>
							</td>
						</tr>
						<?php if(class_exists(ZipArchive)) : ?>
							<tr valign="top">
								<th scope="row"><label for="compress_backup"><?php _e("Compress files with GZIP", WP_BEIFEN_DOMAIN); ?></label></th>
								<td>
									<input type="radio" class="compress_backup" name="compress_backup" value="No" checked="checked" /><?php _e("No", WP_BEIFEN_DOMAIN); ?><br/>
									<input type="radio" class="compress_backup" name="compress_backup" value="Yes" /><?php _e("Yes", WP_BEIFEN_DOMAIN); ?>
								</td>
							</tr>
						<?php endif; ?>
					</table>
				</form>
				<p class="submit">
					<input type="submit" id="wp_beifen_submit" class="button-primary" value="<?php _e("Create New Backup", WP_BEIFEN_DOMAIN); ?>" />
				</p>
			<?php
		}
	?>
</div>