<?php
// Get options
$options = get_option(WP_BEIFEN_OPTIONS);
// Nonce for AJAX activity
$nonce = wp_create_nonce(WP_BEIFEN_NONCE);
?>
<link rel='stylesheet' href='http://192.168.0.100/wordpress/wp-content/plugins/backup/includes/style.css' type='text/css' media='all' />
<script  type='text/javascript'>
/* JQuery stuff for AJAX request and form modification */
jQuery(document).ready(function(){

	// hide update message and directory list
	jQuery("#update_message").hide();
	jQuery("#directory_list_row").hide();
	
	
	// add click event to submit button
	jQuery("#wp_beifen_submit").click(function () {
		// hide directory list
		jQuery("#directory_list_row").hide();
		// prepare form data
		var options = 'backup_directory=' + jQuery("#backup_directory").attr("value");
		// Disable form inputs
		jQuery('#wp_beifen_form :input').attr('disabled', true);
		// Change update message
		jQuery("#update_message").html("<p><img src=\"<?php echo admin_url(); ?>images/loading.gif\" /><?php _e("Creating backup, please don't leave this page!", WP_BEIFEN_DOMAIN); ?></p>");
		// show update message
		jQuery("#update_message").show();
		// send ajax request to save new settings
		send_request('change_settings', options, display_update_result);
    });
	
	// On backup_directory look for existing directories
	jQuery("#backup_directory").keyup(function (e) {
		get_directories();
    });

	// get directories and display them
	function get_directories()
	{
		//prepare form data
		var options = 'backup_directory=' + jQuery("#backup_directory").attr("value");
		send_request('get_directories', options, display_directories);
	}
	
	// send AJAX request
	function send_request(requested_task, options, callback)
	{
		jQuery.ajax({
			type: "post",url: "admin-ajax.php",data: { action: 'wp_beifen_ajax_handler', task:requested_task, parameters:options, _ajax_nonce: '<?php echo $nonce; ?>' },
			beforeSend: function() {},
			complete: function() {},
			success: function(html){
				result = eval("(" + html + ')');
				callback(result);
			}
		})
	}
	
	// display directory list
	function display_directories(directories)
	{
		if(directories.status=='<?php _e("Success", WP_BEIFEN_DOMAIN); ?>') // The path does exist
		{
			// Clear directory list
			jQuery("#directory_list").empty();		
			// Add close button
			jQuery("#directory_list").append('<li id="directory_list_close"><strong><?php _e("Close", WP_BEIFEN_DOMAIN); ?> (X)</strong></li>');
			// Close directory list on clicking directory_list_close
			jQuery("#directory_list_close").click(function () {
				jQuery("#directory_list_row").hide();
			});
			
			if(directories.directories.length>0) // current directory has sub directories?
			{
				for(var i = 0; i < directories.directories.length; i++)
				{
					// Display all subdirectories in the directory list
					jQuery("#directory_list").append('<li class ="directory_list_entry" id="directory_' + i + '">' + directories.directories[i] + '</li>');
				}
				// Add click event to directory list entries
				jQuery("li.directory_list_entry").click(function () {
					jQuery("#backup_directory").attr("value", jQuery(this).html());
					jQuery("#directory_list_row").hide();
					get_directories();
				});
			}
			else // no sub directories
			{
					jQuery("#directory_list").append('<li class ="directory_list_entry" id="directory_empty"><?php _e("Directory is empty!", WP_BEIFEN_DOMAIN); ?></li>');
			}
			
			// Show directory list
			jQuery("#directory_list_row").show();
			// Get sub-directories of new directory
		}
		else // The path does not exist
		{
			jQuery("#directory_list_row").hide();
		}
	}
	
	// display update list
	function display_update_result(result)
	{
		var message = '<h3>' + result.status + '!</h3>'
					+ '<p>' + result.message + '!</p>';
		// Change update message
		jQuery("#update_message").html(message);
		// Enable form inputs
		jQuery('#wp_beifen_form :input').attr('disabled', false);
	}
})

</script>
<div class="wrap">
	<h2><?php _e("Settings", WP_BEIFEN_DOMAIN); ?></h2>
	<div id="update_message" class="updated"></div>
	<form id="wp_beifen_form">
		<table class="form-table">
			<tbody>
				<tr valign="top" id="backup_directory_row" style="position:relative;">
					<th scope="row"><label for="backup_directory"><?php _e("Backup Directory", WP_BEIFEN_DOMAIN); ?></label></th>
					<td>
						<input name="backup_directory" id="backup_directory" value="<?php echo $options['plugin_backup_directory']; ?>" class="regular-text" type="text">
					</td>
				</tr>
				<tr valign="top" id="directory_list_row">
					<th scope="row"><?php _e("Directory List", WP_BEIFEN_DOMAIN); ?></th>
					<td id="directory_list_cell">
						<div>
							<ul id="directory_list">
							</ul>
						</div>
					</td>
				</tr>
			</tbody>
		</table>
	</form>
	<p class="submit">
		<input name="Submit" id="wp_beifen_submit" class="button-primary" value="<?php _e("Save Changes", WP_BEIFEN_DOMAIN); ?>" type="submit">
	</p>
</div>